package org.tsinghua.dcst.gcd.ui.views;

import java.util.HashSet;
import java.util.Set;

import org.eclipse.jface.viewers.TreeViewer;
import org.eclipse.ptp.core.PTPCorePlugin;
import org.eclipse.ptp.core.elements.IResourceManager;
import org.eclipse.swt.SWT;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.ui.model.WorkbenchContentProvider;
import org.eclipse.ui.model.WorkbenchLabelProvider;
import org.eclipse.ui.part.ViewPart;

public class ResourceManagerView extends ViewPart {	


	private final Set<IResourceManager> resourceManagers = new HashSet<IResourceManager>();

	private TreeViewer viewer;
	
	public ResourceManagerView() {
	}
	
	/* (non-Javadoc)
	 * @see org.eclipse.ui.part.WorkbenchPart#createPartControl(org.eclipse.swt.widgets.Composite)
	 */
	public void createPartControl(Composite parent) {
		viewer = new TreeViewer(parent, SWT.MULTI);
		viewer.setContentProvider(new WorkbenchContentProvider());
		viewer.setLabelProvider(new WorkbenchLabelProvider());
		viewer.setInput(PTPCorePlugin.getDefault().getUniverse());

		getSite().setSelectionProvider(viewer);

	}

	public synchronized void dispose() {
		resourceManagers.clear();
		super.dispose();
	}

	public void setFocus() {
		viewer.getControl().setFocus();
	}
}
